/* 
 mando_tractor.sqf v1.1
 August 2007 Mandoble 
*/

_tofollow = _this select 0;
_plane = _this select 1;


private["_plane", "_speed0", "_acc", "_planelength", "_delay", "_deltah", "_vh", "_turn", "_dir", "_ang", "_dif", "_difabs", "_posp", "_post","_vx", "_vy", "_vz", "_speed", "_up", "_ur", "_ux", "_uy", "_uz", "_tofollow", "_log", "_inversion", "_degs"];

_plane       = _this select 0;
_acc         = _this select 1;
_tofollow    = _this select 2;
_planelength = _this select 3;


_speed0   = _speed0 / 3.6;

_delay    = 0.001;
_deltah   = 120 * 4 * _delay;
_vh       = 0;
_turn     = 0;
_dir      = 0;
_ang      = 0;
_dif      = 0;
_difabs   = 0;
_posp     = [0,0,0];
_post     = [0,0,0];
_log = "logic" createVehicleLocal [0,0,0];
_planelength = _planelength / 2;

_taxispd = _speed0;
mando_tractor_hook = true;

_inversion = 1;
_degs = 0;
if ( ((_plane modelToWorld [0,-_planelength,0]) distance _tofollow) < 
     ((_plane modelToWorld [0,_planelength,0]) distance _tofollow) ) then
{
   _inversion = -1;
   _degs = 180;
};

while {mando_tractor_hook} do
{
   _post = getPos _tofollow;
   _log setPos _post;

   _speed0 = 0.5 + abs(speed _tofollow) / 3.6;

   while {((_plane modelToWorld [0,_planelength*_inversion,0] distance _log) > (4+accTime)) && (((_plane modelToWorld [0,_planelength*_inversion,0]) distance _tofollow) < 10) && mando_tractor_hook} do
   {
      _dir = getDir _plane;
      _post = getPos _tofollow;
      _log setPos _post;
      _log setDir (_dir + _degs);
      _dir = getDir _log;

      if (_vh < _taxispd) then
      {
         _vh = _vh + (_acc * accTime) / 2.0;  
      };
      if (_vh > _taxispd) then
      {
         _vh = _vh - (_acc * accTime) / 2.0;  
      };

      _posp = _plane modelToWorld [0,_planelength*_inversion,0];
      _ang = ((_post select 0)-(_posp select 0)) atan2 ((_post select 1)-(_posp select 1));
      _dif = (_ang - _dir);
      if (_dif < 0) then {_dif = 360 + _dif;};
      if (_dif > 180) then {_dif = _dif - 360;};
      _difabs = abs(_dif);
  
      if (_difabs > 1) then
      {
         _turn = _dif/_difabs;
      }
      else
      {
         _turn = 0;
      };

      if (_difabs > 45) then
      {
         _taxispd = _speed0;
      }
      else
      {
         _taxispd = _speed0;
      };

      _dir = _dir + (_turn * ((_deltah * accTime) min (_difabs/100)));
      _vx = (sin _dir)*_vh;
      _vy = (cos _dir)*_vh;
      _vz = -0.01;  

      
      _plane setVectorDir[sin(_dir + _degs), cos(_dir + _degs), 0];
      _plane setVelocity [_vx, _vy, _vz];
      Sleep _delay;
   };

   _plane setVelocity [0, 0, 0];

   if (mando_tractor_hook && ((_plane distance _tofollow) >= (_planelength+10))) then
   {
      mando_tractor_hook = false;
   };
   Sleep _delay;
};
deleteVehicle _log;